tclap 1.2.1

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
TCLAP::ValueArg< T > Class Template Reference

The basic labeled argument that parses a value. More...

`#include <ValueArg.h>`

Inheritance diagram for TCLAP::ValueArg< T >:

## Public Member Functions
| ValueArg (const std::string &flag, const std::string &name, const std::string &desc, bool req, T value, const std::string &typeDesc, Visitor *v=NULL)
| Labeled ValueArg constructor. More...
| ValueArg (const std::string &flag, const std::string &name, const std::string &desc, bool req, T value, const std::string &typeDesc, CmdLineInterface &parser, Visitor *v=NULL)
| Labeled ValueArg constructor. More...
| ValueArg (const std::string &flag, const std::string &name, const std::string &desc, bool req, T value, Constraint< T > *constraint, CmdLineInterface &parser, Visitor *v=NULL)
| Labeled ValueArg constructor. More...
| ValueArg (const std::string &flag, const std::string &name, const std::string &desc, bool req, T value, Constraint< T > *constraint, Visitor *v=NULL)
| Labeled ValueArg constructor. More...
virtual bool | processArg (int *i, std::vector< std::string > &args)
| Handles the processing of the argument. More...
T & | getValue ()
| Returns the value of the argument. More...
virtual std::string | shortID (const std::string &val="val") const
| Specialization of shortID. More...
virtual std::string | longID (const std::string &val="val") const
| Specialization of longID. More...
virtual void | reset ()
| Clears the Arg object and allows it to be reused by new command lines. More...
Public Member Functions inherited from TCLAP::Arg
virtual | ~Arg ()
| Destructor. More...
virtual void | addToList (std::list< Arg * > &argList) const
| Adds this to the specified list of Args. More...
virtual bool | operator== (const Arg &a) const
| Operator ==. More...
const std::string & | getFlag () const
| Returns the argument flag. More...
const std::string & | getName () const
| Returns the argument name. More...
std::string | getDescription () const
| Returns the argument description. More...
virtual bool | isRequired () const
| Indicates whether the argument is required. More...
void | forceRequired ()
| Sets _required to true. More...
void | xorSet ()
| Sets the _alreadySet value to true. More...
bool | isValueRequired () const
| Indicates whether a value must be specified for argument. More...
bool | isSet () const
| Indicates whether the argument has already been set. More...
bool | isIgnoreable () const
| Indicates whether the argument can be ignored, if desired. More...
virtual bool | argMatches (const std::string &s) const
| A method that tests whether a string matches this argument. More...
virtual std::string | toString () const
| Returns a simple string representation of the argument. More...
virtual void | trimFlag (std::string &flag, std::string &value) const
| Trims a value off of the flag. More...
bool | _hasBlanks (const std::string &s) const
| Checks whether a given string has blank chars, indicating that it is a combined SwitchArg. More...
void | setRequireLabel (const std::string &s)
| Sets the requireLabel. More...
virtual bool | allowMore ()
| Used for MultiArgs and XorHandler to determine whether args can still be set. More...
virtual bool | acceptsMultipleValues ()
| Use by output classes to determine whether an Arg accepts multiple values. More...

## Protected Member Functions
void | _extractValue (const std::string &val)
| Extracts the value from the string. More...
Protected Member Functions inherited from TCLAP::Arg
void | _checkWithVisitor () const
| Performs the special handling described by the Vistitor. More...
| Arg (const std::string &flag, const std::string &name, const std::string &desc, bool req, bool valreq, Visitor *v=NULL)
| Primary constructor. More...

## Protected Attributes
T | _value
| The value parsed from the command line. More...
T | _default
| Used to support the reset() method so that ValueArg can be reset to their constructed value. More...
std::string | _typeDesc
| A human readable description of the type to be parsed. More...
Constraint< T > * | _constraint
| A Constraint this Arg must conform to. More...
Protected Attributes inherited from TCLAP::Arg
std::string | _flag
| The single char flag used to identify the argument. More...
std::string | _name
| A single work namd indentifying the argument. More...
std::string | _description
| Description of the argument. More...
bool | _required
| Indicating whether the argument is required. More...
std::string | _requireLabel
| Label to be used in usage description. More...
bool | _valueRequired
| Indicates whether a value is required for the argument. More...
bool | _alreadySet
| Indicates whether the argument has been set. More...
Visitor * | _visitor
| A pointer to a vistitor object. More...
bool | _ignoreable
| Whether this argument can be ignored, if desired. More...
bool | _xorSet
| Indicates that the arg was set as part of an XOR and not on the command line. More...
bool | _acceptsMultipleValues

## Additional Inherited Members
Static Public Member Functions inherited from TCLAP::Arg
static void | beginIgnoring ()
| Begin ignoring arguments since the "--" argument was specified. More...
static bool | ignoreRest ()
| Whether to ignore the rest. More...
static char | delimiter ()
| The delimiter that separates an argument flag/name from the value. More...
static char | blankChar ()
| The char used as a place holder when SwitchArgs are combined. More...
static char | flagStartChar ()
static const std::string | flagStartString ()
static const std::string | nameStartString ()
static const std::string | ignoreNameString ()
| The name used to identify the ignore rest argument. More...
static void | setDelimiter (char c)
| Sets the delimiter for all arguments. More...

## Detailed Description

### template<class T>
class TCLAP::ValueArg< T >

The basic labeled argument that parses a value.

This is a template class, which means the type T defines the type that a given object will attempt to parse when the flag/name is matched on the command line. While there is nothing stopping you from creating an unflagged ValueArg, it is unwise and would cause significant problems. Instead use an UnlabeledValueArg.

Definition at line 43 of file ValueArg.h.

## Constructor & Destructor Documentation

template<class T >

TCLAP::ValueArg< T >::ValueArg | ( | const std::string & | flag,
|  | const std::string & | name,
|  | const std::string & | desc,
|  | bool | req,
|  | T | value,
|  | const std::string & | typeDesc,
|  | Visitor * | v = `NULL`
| ) |  |

Labeled ValueArg constructor.

Constructor implementation.

You could conceivably call this constructor with a blank flag, but that would make you a bad person. It would also cause an exception to be thrown. If you want an unlabeled argument, use the other constructor.

Parameters

  flag | - The one character flag that identifies this argument on the command line.
  name | - A one word name for the argument. Can be used as a long flag on the command line.
  desc | - A description of what the argument is for or does.
  req | - Whether the argument is required on the command line.
  value | - The default value assigned to this argument if it is not present on the command line.
  typeDesc | - A short, human readable description of the type that this object expects. This is used in the generation of the USAGE statement. The goal is to be helpful to the end user of the program.
  v | - An optional visitor. You probably should not use this unless you have a very good reason.

Definition at line 252 of file ValueArg.h.

template<class T >

TCLAP::ValueArg< T >::ValueArg | ( | const std::string & | flag,
|  | const std::string & | name,
|  | const std::string & | desc,
|  | bool | req,
|  | T | value,
|  | const std::string & | typeDesc,
|  | CmdLineInterface & | parser,
|  | Visitor * | v = `NULL`
| ) |  |

Labeled ValueArg constructor.

You could conceivably call this constructor with a blank flag, but that would make you a bad person. It would also cause an exception to be thrown. If you want an unlabeled argument, use the other constructor.

Parameters

  flag | - The one character flag that identifies this argument on the command line.
  name | - A one word name for the argument. Can be used as a long flag on the command line.
  desc | - A description of what the argument is for or does.
  req | - Whether the argument is required on the command line.
  value | - The default value assigned to this argument if it is not present on the command line.
  typeDesc | - A short, human readable description of the type that this object expects. This is used in the generation of the USAGE statement. The goal is to be helpful to the end user of the program.
  parser | - A CmdLine parser object to add this Arg to
  v | - An optional visitor. You probably should not use this unless you have a very good reason.

Definition at line 267 of file ValueArg.h.

References TCLAP::CmdLineInterface::add().

template<class T >

TCLAP::ValueArg< T >::ValueArg | ( | const std::string & | flag,
|  | const std::string & | name,
|  | const std::string & | desc,
|  | bool | req,
|  | T | value,
|  | Constraint< T > * | constraint,
|  | CmdLineInterface & | parser,
|  | Visitor * | v = `NULL`
| ) |  |

Labeled ValueArg constructor.

You could conceivably call this constructor with a blank flag, but that would make you a bad person. It would also cause an exception to be thrown. If you want an unlabeled argument, use the other constructor.

Parameters

  flag | - The one character flag that identifies this argument on the command line.
  name | - A one word name for the argument. Can be used as a long flag on the command line.
  desc | - A description of what the argument is for or does.
  req | - Whether the argument is required on the command line.
  value | - The default value assigned to this argument if it is not present on the command line.
  constraint | - A pointer to a Constraint object used to constrain this Arg.
  parser | - A CmdLine parser object to add this Arg to.
  v | - An optional visitor. You probably should not use this unless you have a very good reason.

Definition at line 300 of file ValueArg.h.

References TCLAP::CmdLineInterface::add().

template<class T >

TCLAP::ValueArg< T >::ValueArg | ( | const std::string & | flag,
|  | const std::string & | name,
|  | const std::string & | desc,
|  | bool | req,
|  | T | value,
|  | Constraint< T > * | constraint,
|  | Visitor * | v = `NULL`
| ) |  |

Labeled ValueArg constructor.

You could conceivably call this constructor with a blank flag, but that would make you a bad person. It would also cause an exception to be thrown. If you want an unlabeled argument, use the other constructor.

Parameters

  flag | - The one character flag that identifies this argument on the command line.
  name | - A one word name for the argument. Can be used as a long flag on the command line.
  desc | - A description of what the argument is for or does.
  req | - Whether the argument is required on the command line.
  value | - The default value assigned to this argument if it is not present on the command line.
  constraint | - A pointer to a Constraint object used to constrain this Arg.
  v | - An optional visitor. You probably should not use this unless you have a very good reason.

Definition at line 285 of file ValueArg.h.

## Member Function Documentation

template<class T >

void TCLAP::ValueArg< T >::_extractValue | ( | const std::string & | val | ) |
| protected

Extracts the value from the string.

Attempts to parse string as type T, if this fails an exception is thrown.

Parameters

  val | - value to be parsed.

Definition at line 400 of file ValueArg.h.

References TCLAP::ArgException::error(), and TCLAP::ExtractValue().

template<class T >

T & TCLAP::ValueArg< T >::getValue | ( |  | ) |

Returns the value of the argument.

Implementation of getValue().

Definition at line 322 of file ValueArg.h.

template<class T >

std::string TCLAP::ValueArg< T >::longID | ( | const std::string & | val = `"val"` | ) | const
| virtual

Specialization of longID.

Implementation of longID.

Parameters

  val | - value to be used.

Reimplemented from TCLAP::Arg.

Reimplemented in TCLAP::UnlabeledValueArg< T >.

Definition at line 393 of file ValueArg.h.

References TCLAP::Arg::longID().

template<class T >

bool TCLAP::ValueArg< T >::processArg | ( | int * | i,
|  | std::vector< std::string > & | args
| ) |  |
| virtual

Handles the processing of the argument.

Implementation of processArg().

This re-implements the Arg version of this method to set the _value of the argument appropriately. It knows the difference between labeled and unlabeled.

Parameters

  i | - Pointer the the current argument in the list.
  args | - Mutable list of strings. Passed in from main().

Implements TCLAP::Arg.

Reimplemented in TCLAP::UnlabeledValueArg< T >.

Definition at line 328 of file ValueArg.h.

References TCLAP::Arg::delimiter(), and TCLAP::Arg::ignoreRest().

template<class T >

void TCLAP::ValueArg< T >::reset | ( |  | ) |
| virtual

Clears the Arg object and allows it to be reused by new command lines.

Reimplemented from TCLAP::Arg.

Definition at line 417 of file ValueArg.h.

References TCLAP::Arg::reset().

template<class T >

std::string TCLAP::ValueArg< T >::shortID | ( | const std::string & | val = `"val"` | ) | const
| virtual

Specialization of shortID.

Implementation of shortID.

Parameters

  val | - value to be used.

Reimplemented from TCLAP::Arg.

Reimplemented in TCLAP::UnlabeledValueArg< T >.

Definition at line 383 of file ValueArg.h.

References TCLAP::Arg::shortID().

## Member Data Documentation

template<class T>

Constraint<T>* TCLAP::ValueArg< T >::_constraint
| protected

A Constraint this Arg must conform to.

Definition at line 72 of file ValueArg.h.

template<class T>

T TCLAP::ValueArg< T >::_default
| protected

Used to support the reset() method so that ValueArg can be reset to their constructed value.

Definition at line 58 of file ValueArg.h.

template<class T>

std::string TCLAP::ValueArg< T >::_typeDesc
| protected

A human readable description of the type to be parsed.

This is a hack, plain and simple. Ideally we would use RTTI to return the name of type T, but until there is some sort of consistent support for human readable names, we are left to our own devices.

Definition at line 67 of file ValueArg.h.

template<class T>

T TCLAP::ValueArg< T >::_value
| protected

The value parsed from the command line.

Can be of any type, as long as the >> operator for the type is defined.

Definition at line 52 of file ValueArg.h.

The documentation for this class was generated from the following file:

- ValueArg.h